config() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  # If there's no config file by that name, mv it over:
  if [ ! -r $OLD ]; then
    mv $NEW $OLD
  elif [ "$(cat $OLD | md5sum)" = "$(cat $NEW | md5sum)" ]; then
    # toss the redundant copy
    rm $NEW
  fi
  # Otherwise, we leave the .new copy for the admin to consider...
}

preserve_perms() {
  NEW="$1"
  OLD="$(dirname $NEW)/$(basename $NEW .new)"
  if [ -e $OLD ]; then
    cp -a $OLD ${NEW}.incoming
    cat $NEW > ${NEW}.incoming
    mv ${NEW}.incoming $NEW
  fi
  config $NEW
}

# inittab -- modify serial port entry 's0'
if grep -q '^s0:.*ttyS0' etc/inittab ; then
  sed -i     -e 's;^s0:12345:respawn:/sbin/agetty 115200 ttyS0 vt100$;#s0:12345:respawn:/sbin/agetty -L ttyAMA0 9600 vt100;'     etc/inittab
fi

# rc.local -- set time from network
if ! grep -q sntp etc/rc.d/rc.local ; then
  echo '' >> etc/rc.d/rc.local
  echo "# Added by raspi-hacks-2.1-arm-1_dbs" >> etc/rc.d/rc.local
  echo 'sntp -s pool.ntp.org >/dev/null &' >> etc/rc.d/rc.local
fi

# e2fsck.conf -- hardware clock fix
config etc/e2fsck.conf.new

# hwclock -- reinstate the original if moved by previous raspi-hacks
if [ -f sbin/hwclock.orig ]; then
  rm -f sbin/hwclock
  mv sbin/hwclock.orig sbin/hwclock
fi

# sysctl.conf -- set vm.min_free_kbytes
config etc/sysctl.conf.new

# libcofi_rpi.sh -- activate replacement memcpy/memset
preserve_perms etc/profile.d/libcofi_rpi.sh.new
preserve_perms etc/profile.d/libcofi_rpi.csh.new

